% Script to download game info data and update the tables in the DATA
% directory.
fix_path;
clear all;
%urlwrite('http://football-data.co.uk/mmz4281/1213/E0.csv','PL.csv');
%urlwrite('C:/Users/Martin/Documents/Skole/Footy/DATA/2012-13/crawled-PL.csv','PL.csv');

%urlwrite('http://localhost:8081/testmappe/crawled-PL.csv','PL.csv');
%allContents = read_mixed_csv('PL.csv', ',');
allContents = read_mixed_csv('../DATA/2012-13/crawled-PL.csv',',');
db = Database();
db = db.LoadDataset('season', '2012-13', 'league', 'PL');

% Parse for the interesting columns.
% The ones I am after have headers kept in a cell-array
% Note that the first three are always HomeTeam, AwayTeam, date. This is
% FIXED AND USED LATER ON
relevantColumn{1}.Name  = 'HomeTeam'; % String - must be translated
relevantColumn{1}.Type  = 'Team';
relevantColumn{1}.Index = NaN;
relevantColumn{2}.Name  = 'AwayTeam'; % String - must be translated
relevantColumn{2}.Type  = 'Team';
relevantColumn{2}.Index = NaN;
relevantColumn{3}.Name  = 'Date';
relevantColumn{3}.Type  = 'Date';
relevantColumn{3}.Index = NaN;
relevantColumn{4}.Name  = 'FTHG'; % Full time home goals
relevantColumn{4}.Type  = 'Numeric';
relevantColumn{4}.Index = NaN;
relevantColumn{5}.Name  = 'FTAG'; % Full time Away goals
relevantColumn{5}.Type  = 'Numeric';
relevantColumn{5}.Index = NaN;
relevantColumn{6}.Name  = 'HS'; % Home Shots
relevantColumn{6}.Type  = 'Numeric';
relevantColumn{6}.Index = NaN;
relevantColumn{7}.Name  = 'AS'; % Away shots
relevantColumn{7}.Type  = 'Numeric';
relevantColumn{7}.Index = NaN;
relevantColumn{8}.Name  = 'HST'; % Home shots on target
relevantColumn{8}.Type  = 'Numeric';
relevantColumn{8}.Index = NaN;
relevantColumn{9}.Name  = 'AST'; % Away shots on target
relevantColumn{9}.Type  = 'Numeric';
relevantColumn{9}.Index = NaN;
%TESTING ADDITIONAL COLUMNS; REMOVE THESE FOR GETTING INFO FROM
%FOOTBALL-DATA.CO.UK
relevantColumn{10}.Name  = 'HomeBlockedShots'; % Number of shots by hometeam blocked by awayteam
relevantColumn{10}.Type  = 'Numeric';
relevantColumn{10}.Index = NaN;
relevantColumn{11}.Name  = 'AwayBlockedShots'; % Number of shots by awayteam blocked by hometeam.
relevantColumn{11}.Type  = 'Numeric';
relevantColumn{11}.Index = NaN;

relevantColumn{12}.Name  = 'HomePossession'; % Home Possesson given as a number between 0 and 100.
relevantColumn{12}.Type  = 'Numeric';
relevantColumn{12}.Index = NaN;
relevantColumn{13}.Name  = 'AwayPossession'; % Away Possession given as a number between 0 and 100.
relevantColumn{13}.Type  = 'Numeric';
relevantColumn{13}.Index = NaN;

relevantColumn{14}.Name  = 'HomeAttemptedPasses'; % Number of attempted passes
relevantColumn{14}.Type  = 'Numeric';
relevantColumn{14}.Index = NaN;
relevantColumn{15}.Name  = 'AwayAttemptedPasses'; % Number of attempted passes
relevantColumn{15}.Type  = 'Numeric';
relevantColumn{15}.Index = NaN;

relevantColumn{16}.Name  = 'HomeSuccessfulPasses'; % Number of successful passes
relevantColumn{16}.Type  = 'Numeric';
relevantColumn{16}.Index = NaN;
relevantColumn{17}.Name  = 'AwaySuccessfulPasses'; % Number of successful passes
relevantColumn{17}.Type  = 'Numeric';
relevantColumn{17}.Index = NaN;

relevantColumn{18}.Name  = 'HomeWonContests'; % Number of contests on free balls won
relevantColumn{18}.Type  = 'Numeric';
relevantColumn{18}.Index = NaN;
relevantColumn{19}.Name  = 'AwayWonContests'; % Number of contests on free balls won
relevantColumn{19}.Type  = 'Numeric';
relevantColumn{19}.Index = NaN;

relevantColumn{20}.Name  = 'HomeTackles'; % Number of successful tackles on the ball
relevantColumn{20}.Type  = 'Numeric';
relevantColumn{20}.Index = NaN;
relevantColumn{21}.Name  = 'AwayTackles'; % Number of successful tackles on the ball
relevantColumn{21}.Type  = 'Numeric';
relevantColumn{21}.Index = NaN;

relevantColumn{22}.Name  = 'HomeAerialWon'; % Number of aerial balls won
relevantColumn{22}.Type  = 'Numeric';
relevantColumn{22}.Index = NaN;
relevantColumn{23}.Name  = 'AwayAerialWon'; % Number of aerial balls lost
relevantColumn{23}.Type  = 'Numeric';
relevantColumn{23}.Index = NaN;









% Pick out the relevant indexes in the database
chosenFields = zeros(length(relevantColumn), 1);
for field = 1:length(relevantColumn)
    relevantColumn{field}.Index = find(strcmpi(cellstr(allContents(1,:)), relevantColumn{field}.Name));
    chosenFields(field) = relevantColumn{field}.Index;
end
contents = allContents(2:end, chosenFields);

% Data transformations
for field = 1:length(relevantColumn)
    switch relevantColumn{field}.Type
        case 'Date'
            contents(:, field) = cellfun(@(s) {datenum(cellstr(s), 'dd/mm/yy')}, contents(:, field));
        case 'Team'
            contents(:, field) = cellfun(@(s) {db.GetTeam(cellstr(s))}, contents(:, field));
        case 'Numeric'
            contents(:, field) = cellfun(@(s) {str2double(s)}, contents(:, field));
        otherwise
            warning([' Field type ' relevantColumn{field}.Type ' not known -- conversion trouble...']);
    end
end

% Move data to the results - table
oldData = load('../DATA/2012-13/PL.mat');
results = oldData.results;
results(:, 3:end) = NaN;
noResults = size(results,2) - 2;
for record = 1:size(contents, 1)
    chooser = (results(:,1)== cell2mat(contents(record, 1))) & ...
        (results(:,2)== cell2mat(contents(record, 2)));
    % -- will be a vector of zeros, with a single '1'
    if sum(chooser) ~=1
        warning('Not able to find a game');
    end
    results(find(chooser, 1), 3:end) = cell2mat(contents(record, 4:3+noResults));
end
save('../DATA/2012-13/PL.mat', 'results', '-append');

% Move data to the schedule - table
schedule = oldData.schedule;
schedule(:, 4) = NaN;
startDate = min(cell2mat(contents(:, 3)));
for record = 1:size(contents, 1)
    chooser = (schedule(:,2)== cell2mat(contents(record, 1))) & ...
        (schedule(:,3)== cell2mat(contents(record, 2)));
    % -- will be a vector of zeros, with a single '1'
    if sum(chooser) ~=1
        warning('Not able to find a game');
    end
    schedule(find(chooser, 1), 4) = cell2mat(contents(record, 3)) - startDate;
end
% Trick: JAGS does not work well when gameDate is NaN. So, for games not
% yet played, I am guessing them to be played "in the future" following the
% formula GameDate = LatestDay + 7 * (roundIndex - currentRound).
%If GameDate is in the past (i.e.,  roundIndex < currentRound, I use a
%random number between LatestDay and EndOfSeason. Note the offset-trick for
%the random allocation below (adding .5). This is to avoid to games being
%played exactly at the same time, thereby giving precision infinity
latestDay    = max(schedule(~isnan(schedule(:, 4)), 4));
currentRound = max(schedule(~isnan(schedule(:, 4)), 1));
endOfSeason  = latestDay + 7 * (db.GetNoRounds() - currentRound);
for record = 1:size(schedule, 1)
    if isnan(schedule(record, 4))
        if schedule(record, 1) >= currentRound
            schedule(record, 4) = latestDay + 7 * (schedule(record, 1) - currentRound);
        else
            schedule(record, 4) = latestDay + 0.5 + round(rand(1)*(endOfSeason-latestDay));
        end
    end
end
save('../DATA/2012-13/PL.mat', 'schedule', '-append');

% ... and now the bookies
clear relevantColumn;

% Move data to the results - table
oldData = load('../DATA/2012-13/PL.mat');
results = oldData.results;

%DO ONCE TO GET DIMENSIONS FOR OLDRESULTS CORRECT


%--------------- 
results(:, 3:end) = NaN;
noResults = size(results,2) - 2;
for record = 1:size(contents, 1)
    chooser = (results(:,1)== cell2mat(contents(record, 1))) & ...
        (results(:,2)== cell2mat(contents(record, 2)));
    % -- will be a vector of zeros, with a single '1'
    if sum(chooser) ~=1
        warning('Not able to find a game');
    end
    results(find(chooser, 1), 3:end) = cell2mat(contents(record, 4:3+noResults));
end
save('../DATA/2012-13/PL.mat', 'results', '-append');

%ADD THESE 4 lines when getting csv file from football-data.co.uk!

%bookieColumn{1}.Name  = 'WilliamHill'; % Name of object in MAT-file
%bookieColumn{1}.Code  = 'WH';  % Name of fields in CSV file will be <code>H, <code>D, <code>A, eg WHA, WHD, WHA for WH-code
%bookieColumn{2}.Name  = 'Ladbrokes'; % Name of object in MAT-file
%bookieColumn{2}.Code  = 'LB';  % Name of fields in CSV file will be <code>H, <code>D, <code>A, eg WHA, WHD, WHA for WH-code

bookieColumn{1}.Name = 'BestBookie';
bookieColumn{1}.Code = 'odds';

for field = 1:length(bookieColumn)
    % Pick out the relevant indexes in the database
    chosenFields = zeros(5, 1);
    chosenFields(1) = find(strcmpi(cellstr(allContents(1,:)), 'HomeTeam'));
    chosenFields(2) = find(strcmpi(cellstr(allContents(1,:)), 'AwayTeam'));
    chosenFields(3) = find(strcmpi(cellstr(allContents(1,:)), [bookieColumn{field}.Code 'H']));
    chosenFields(4) = find(strcmpi(cellstr(allContents(1,:)), [bookieColumn{field}.Code 'D']));
    chosenFields(5) = find(strcmpi(cellstr(allContents(1,:)), [bookieColumn{field}.Code 'A']));
    
    
    %contents = cellfun(@(s) {str2double(s)}, allContents(2:end, chosenFields));
    contents = allContents(2:end, chosenFields);
    contents(:, 1) = cellfun(@(s) {db.GetTeam(cellstr(s))}, contents(:, 1));
    contents(:, 2) = cellfun(@(s) {db.GetTeam(cellstr(s))}, contents(:, 2));
    contents(:,3:5)= cellfun(@(s) {str2double(s)}, contents(:, 3:5));
    contents = cell2mat(contents);
    
    
    
    % Move data to the results - table
    %bookie = load('../DATA/2012-13/PL-odds.mat', bookieColumn{field}.Name);
    %bookie(:, 3:end) = NaN;
    bookie = nan(db.GetNoGames(), 5);
    bookie(:, 1:2) = results(:, 1:2); % copy over the schedules.
    
    for record = 1:size(contents, 1)
        chooser = (bookie(:,1) == contents(record, 1)) & ...
            (bookie(:,2)== contents(record, 2));
        % -- will be a vector of zeros, with a single '1'
        if sum(chooser) ~=1
            warning('Not able to find a game');
        end
        bookie(find(chooser, 1), 3:5) = contents(record, 3:5);
    end
    eval([bookieColumn{field}.Name ' = bookie;']);
    save('../DATA/2012-13/PL-odds.mat', bookieColumn{field}.Name, '-append');
end



