<?php

/*
This file mainly handles searching through strings for match statistics, and returns an ordered string containing the match attributes found. If an attribute is missing
(E.g., if there were no shots that hit the post, this attribute will be missing in the string, it will not have a snippet that says [post_shots, [0]].

*/

/*
				GLOBALS - ATTRIBUTES

*/



	$listOfAttributes = array(	'\'blocked_scoring_att\'',  
								'\'shot_off_target\'',
								'\'ontarget_scoring_att\'',
								'\'post_scoring_att\'', 
								'\'total_scoring_att\'', 
								'\'won_contest\'',  
								'\'fk_foul_lost\'',
								'\'total_throws\'', 
								'\'total_tackle\'', 
								'\'total_offside\'', 
								'\'won_corners\'', 
								'\'total_pass\'',
								'\'accurate_pass\'', 
								'\'possession_percentage\'',  
								'\'aerial_lost\'',
								'\'aerial_won\'',  
								'\'goals\''); 
								
	/*
		DATA MISSING WHICH CAN BE OBTAINED FROM http://football-data.co.uk/mmz4281/1213/E0.csv:
				
								yellow cards
								red cards
								
		DATA MISSING WHICH ARE NOT CLEAR WHERE COULD BE OBTAINED
		
								total crosses
								
	*/

	function addTitlesToFixtureInfoColumns($array){
		if(sizeof($array)==0){
			echo "size is 0</br>";
			global $listOfAttributes;
			$result = "MatchID,HomeID,AwayID,HomeTeam,AwayTeam,MatchDate,Result";
		
			foreach($listOfAttributes as $attr){
				$attr = ltrim($attr, "\'");
				$result=$result.",'home_".$attr;
			}
		
			foreach($listOfAttributes as $attr){
				$attr = ltrim($attr, "\'");
				$result=$result.",'away_".$attr;
			}
			$array[] = $result;
			return $array;
		}
		
		return array();
	}

	function findAttributes($infoString){
		global $listOfAttributes;
		$resultString = "";
		foreach($listOfAttributes as $attr){
			$pattern = "/".$attr.",\[\d+(.\d+)?\]\]/";
			if(preg_match($pattern, $infoString, $matches)){
				//echo $matches[0]."     ";
				if(preg_match("/\d+/", $matches[0], $digit)){
				//	echo $digit[0]."</br>";
					$resultString = $resultString.$digit[0].",";
				}
			}
			else{
					$resultString =$resultString."0,";
			}
		}
		$resultString = rtrim($resultString, ",");
		//echo $resultString."</br>";
		return $resultString;
	
	}


/*
	Some Important Lines in subject (examples through sourcecode)
	
	matchHeader.load([171,24,'Queens Park Rangers','Aston Villa','12/01/2012 15:00:00','12/01/2012 00:00:00',6,'FT','1 : 1','1 : 1',,,'1 : 1'] 				-> Date, Teams, result.
	
	
	, [[171,'Queens Park Rangers',
	6.84,
	[[['blocked_scoring_att',[5]],['post_scoring_att',[1]],['att_goal_low_left',[1]],['accurate_pass',[371]],['att_miss_left',[1]],['total_tackle',[20]],
	['total_offside',[9]],['att_sv_low_left',[2]],['att_sv_high_right',[1]],['att_sv_low_centre',[1]],['won_contest',[11]],['att_sv_high_left',[1]],
	['shot_off_target',[4]],['ontarget_scoring_att',[8]],['total_scoring_att',[17]],['aerial_lost',[15]],['att_sv_low_right',[2]],['fk_foul_lost',[5]],
	['total_throws',[24]],['won_corners',[11]],['possession_percentage',[54.5]],['att_post_right',[1]],['aerial_won',[19]],['total_pass',[447]],
	['att_miss_high_right',[2]],['goals',[1]]]],[[7890,'Robert Green',5.34,

	,[24,'Aston Villa',
	6.72,
	[[['blocked_scoring_att',[1]],['accurate_pass',[305]],['att_miss_left',[1]],['total_tackle',[21]],
	['total_offside',[4]],['won_contest',[6]],['att_goal_low_right',[1]],
	['shot_off_target',[4]],['ontarget_scoring_att',[2]],['total_scoring_att',[7]],['aerial_lost',[19]],['att_sv_low_right',[1]],['fk_foul_lost',[6]],
	['total_throws',[20]],['won_corners',[4]],['possession_percentage',[45.5]],['aerial_won',[15]],['total_pass',[389]],
	['att_miss_high',[1]],['att_miss_high_right',[1]],['att_miss_high_left',[1]],['goals',[1]]]],[[28746,'Brad Guzan',7.15,
	
	*/
?>