<?php
//<h1>Premier League Results & Historical Odds</h1>

include_once("simple_html_dom.php");

/* GLOBAL */
$ERROR_OCCURED = FALSE;
$oddsTimer = time();
$oddsMaxTime = 20;
$oddsList = array();

$UpcMatchCount = getUpcomingMatchesCount();
$oddsToFindCount = 0;
$teamNameTransWhoScoredToBetExplorer = array(		"'Manchester United'" 	=> "Manchester United", 
													"'Manchester City'"		=> "Manchester City",
													"'Chelsea'"				=> "Chelsea",
													"'Tottenham'"			=> "Tottenham",
													"'Arsenal'"				=> "Arsenal",
													"'Everton'"				=> "Everton",
													"'Swansea'"				=> "Swansea",
													"'West Bromwich Albion'"=> "West Brom",
													"'Liverpool'"			=> "Liverpool",
													"'Stoke'"				=> "Stoke City",
													"'West Ham'"			=> "West Ham",
													"'Fulham'"				=> "Fulham",
													"'Sunderland'"			=> "Sunderland",
													"'Norwich'"				=> "Norwich",
													"'Southampton'"			=> "Southampton",
													"'Newcastle United'"	=> "Newcastle Utd",
													"'Aston Villa'"			=> "Aston Villa",
													"'Reading'"				=> "Reading",
													"'Wigan'"				=> "Wigan",
													"'Queens Park Rangers'"	=> "QPR");



/* /END GLOBAL */


function getBestOdds(){
	echo "Retrieving best available...</br>\n";
	global $target_url_for_betexplorer_odds, $csv_odds, $UpcMatchCount, $oddsToFindCount, $oddsTimer, $oddsMaxTime, $ERROR_OCCURED;
	$matches = listOfMatchesToQuery(); //returns pairs of teams to play each other.
	if(sizeof($matches)==0){
		echo "There are no upcoming matches to find odds for!</br>\n";
		return;
	}
	$start = findUpcomingMatchesStartPos($matches);
	if(strpos($start,'Error') !== false) {
		echo "retreiving odds aborted! </br>REASON: ".$start."\n";
		return;
	}
	$matches = array_slice($matches, $UpcMatchCount-$oddsToFindCount);
	
	echo "startpos for new matches to find odds for in oddsfile: ".$start."</br>\n";
	echo "Number of matches to find new odds for: ".$oddsToFindCount."</br>\n";
	$target_url = $target_url_for_betexplorer_odds;
	$html = new simple_html_dom();
	$html->load_file($target_url);
	$subject = $html;
	$matchodds;
	
	$i = 0;
	foreach($matches as $pair){
		echo "Finding odds for: ".$pair[0]." - ".$pair[1]."</br>\n";
		++$i;
		$link = getLinkToMatch($pair, $subject);
		if (strpos($link,'Error') !== false) {
			echo "Updating odds aborted: You may need to verify that the 'upcomingfixtures' file  has been updated first";
			$ERROR_OCCURED = true;
			break;
		}
		$matchodds = getBestOddsForMatch($link);
		appendToOddsList($matchodds, $pair);
		if(exceededTimeLimit($oddsTimer, $oddsMaxTime)){
			echo "exceeded time limit!</br>\n";
			break;
		}
	}
	//echo $i;
	if($ERROR_OCCURED == false && $i>0){
		addNewOddsToFile($csv_odds, $i, $start);
		echo "Finished Retrieval of best odds!</br>\n";
	}
}

/*
	Find out which fixtures we need to find odds for in the oddsfile, and which we do not need to update (played games will not have updated odds).
	
	$matches - list of matches retrieved from upcomingfixtures.csv, which we want to update the odds for.
	$index   - which match in $matches we are currently looking at. $Index also gives the number of upcoming matches which we already have odds for.
*/

function findUpcomingMatchesStartPos($matches){
	global $csv_odds, $oddsToFindCount, $UpcMatchCount, $ERROR_OCCURED;
	$position = 0;
	$upcomingMatchPos = 0;
	$index = 0;
	$matchesNotInFile = true;
	$fh = fopen($csv_odds, 'r') or die("can't open file");
	if ($fh) {
		while (($buffer = fgets($fh, 4096)) !== false) {										//Loop through every match we have obtained odds for
			$position++;
			$fixture = explode(",", $buffer);													//Fixture holds the names of the two teams
			if($matches[$index][0] == $fixture[1] && $matches[$index][1] == $fixture[2]){		//Odds has already been obtained for this upcoming match! 
				//echo "match: ".$fixture[1]."-".$fixture[2]." -- OddstofindCount: ".$oddsToFindCount." -- Upcomingmatchcount: ".$UpcMatchCount."</br>\n";
				$upcomingMatchPos = $position;													//Cache the position of the last match which we already have odds for.
				if($fixture[0] == "1"){															//This odds may already be recently updated,
					//echo "This game has already been updated. Increase index and see if there exists a \"0\"</br>\n";
					$index++;																	//Check next match in $matches by increasing $index.
				}
				
				if($fixture[0] == "0"){															//This match has update-priority over other matches, we should update 0's if they exist. 
					$oddsToFindCount = $UpcMatchCount - $index;									//The first '$index' matches have updated odds, we need to skip these and update the last '$oddsTofindCount' number of matches.
					fclose($fh);
					echo "Found a \"0\", oddstofindcount = ".$oddsToFindCount." -- position = ".$position." index -- ".$index ."</br>\n";
					return $position-1;
				}
			}
			elseif($index > 0){																	// didnt find match, but we have previously found matches.
				echo "An unexpected problem occured. The findUpcomingMatchesStartPos method in
						get_odds.php Assumes that matches have same sequence in odds.csv as upcomingfixtures.csv.</br>
						Apparantly after first finding a match between the files, the next match in upcomingFixtures was not found in odds. You may need to alter sequence in one 
						of the files so they match!<br>\n";
						
				return("Error: Problem when assessing which matches to update. May be a mismatch in sequence of upcomingmatches in the oddsfile.csv (Matches at bottom of file)
						compared to sequence in upcomingfixtures.csv. </br> Error occured for: ".$fixture[1]."-".$fixture[2].". </br></br>We suggest changing sequence of the last
						matches in the odds-file so that they match the sequence in upcomingfixtures.csv, since an update of upcomingfixtures.csv (Which must be done several times a week)
						will make the sequences differ from each other again.");
			}
		}
		if($index < $UpcMatchCount){
			$oddsToFindCount = $UpcMatchCount - $index;
			echo "There are ".$UpcMatchCount." upcoming matches identified, of these, we have already obtained odds for the first ".$index." matches.
				  We will now obtain odds for the remaining ".$oddsToFindCount." matches. </br\n"; 
			fclose($fh);
			return $position;
		}
		$oddsToFindCount = $UpcMatchCount;
		//echo "oddsToFind has been set!</br>\n";
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
	}
	return $position-$index;
}

function getSpecificOdds($BookieName){
	echo "Retrieving odds from ".$BookieName."...</br>\n";
	global $teamNameTransWhoScoredToBetExplorer, $oddsList, $target_url_for_betexplorer_odds;
	
	$matches = listOfMatchesToQuery();
	$target_url = $target_url_for_betexplorer_odds;
	$html = new simple_html_dom();
	$html->load_file($target_url);
	$subject = $html;
	$matchodds;
	$i = 0;
	foreach($matches as $pair){
	echo ++$i;
		$link = getLinkToMatch($pair, $subject);
		$matchodds = getBookieOdds($link, $BookieName);
		appendToOddsList($matchodds, $pair);
	}
	addNewOddsToFile($oddsList);
	echo "Finished Retrieval from ".$BookieName."!</br>\n";
}


function getLinkToMatch($pair, $subject){
	global $target_url_for_betexplorer_odds;
	$pattern = "/.*>".$pair[0]." - ".$pair[1]."<.*/";
	if(preg_match($pattern, $subject, $matches)){
		//echo "Matches: ".$matches[0]."</br>\n";
		#$pattern = "/nextmatch.php\?.*\d\d\d\">/";			#old version, changed 01.05.2013 Because of error, links seem to generally have an id of length 8, 
															#using both numbers and small and large letters, i.e. nextmatch.php?matchid=12dFsFO8">
															#	It seems they used to have a general pattern where they ended in 3 digits. Worked for 34 rounds.
		$pattern = "/nextmatch.php\?matchid=.{8}\">/";
		if(preg_match($pattern, $matches[0], $result)){
			$result[0] = trim($result[0], " \">");
			//echo "Matches: ".$result[0]."</br>\n";
			return $target_url_for_betexplorer_odds.$result[0];
		}
		else{
			echo "Could not find match for the pattern for finding specific match link: ".$pattern;
		}
	}
	else{
		echo "Could not find a match for the pattern for finding snippet that contains specific match link: ".$pattern." </br>Are you sure that betexplorer has set up odds for this match?</br>
		 <a href=\"".$target_url_for_betexplorer_odds."\">Check Betexplorer if odds for the match ".$pair[0]." - ".$pair[1]." exist</a> </br></br>Two most likely causes of problem: </br>
		 1: You have not updated upcomingfixtures.csv, and the match you are attempting to get odds for has already been played, therefore it no longer exists on the page we are checking.</br>
		 2: The match is too far into the future, and odds has not been set for the match yet.</br></br>
		 Solution: Make sure upcomingfixtures.csv is updated. If odds are not yet set for the match, remove this match and all subsequent matches From the upcomingfixtures.</br>";
		
	}
	return "Error: Could not find match for the game between ".$pair[0]." and ".$pair[1];

}

function getBestOddsForMatch($link){
	$target_url = $link;
	$html = new simple_html_dom();
	$html->load_file($target_url);
	$subject = $html;
	$odds = array();
	$pattern = "/(<tr><th.*<\/td><\/tr>)|(<tr class=\"strong\"><th class=\"first-cell nobr\">.*<\/td><\/tr>)/";
	if(preg_match_all($pattern, $subject, $matches)){
		foreach($matches[0] as $match){
			//echo $match."</br>\n";
			if(preg_match_all('/\"\d\d?\.\d\d\"/', $match, $m)){
				$bookieName = getBookieName($match);
				//echo $bookieName."</br>\n";
				$odds[] = array($bookieName, trim($m[0][0], "\", "), trim($m[0][1], "\", "), trim($m[0][2], "\", "));
				
			}
		}
	}
	//print_r($odds);
	if(sizeof($odds) > 1){
		return findBestOdds($odds); //besthome, odds, bestdraw, odds, bestaway, odds
	}
}

function getBookieOdds($link, $BookieName){
	//echo $link."</br>\n";
	$target_url = $link;
	$html = new simple_html_dom();
	$html->load_file($target_url);
	$subject = $html;
	$pattern = "/<\/span>".$BookieName."<\/a>.*/";
	if(preg_match($pattern, $subject, $matches)){
		//echo "Matches: ".$matches[0]."</br>\n";
		if(preg_match_all('/\"\d\.\d\d\"/', $matches[0], $odds)){
				$matchodds=array();
				foreach($odds[0] as $o){
					$o = trim($o, "\"");
					$matchodds[] = $o;
					//echo $o." ";
				}
				//echo "</br>";
				return $matchodds;
			}
			else{
				echo "Could not find the odds for bookie '".$BookieName."' for the following match: <a href=\"".$link."\">Match</a>Does the regex apply to the source code of that page?</br>\n";
				return "error";
			}
	}
	else{
		echo "Could not find match for bookie '".$BookieName."' for the following match: <a href=\"".$link."\">Match</a></br>\n";
		return "error";
	}

}


function getBetExplorerOdds(){
	global $teamNameTransWhoScoredToBetExplorer, $oddsList;
	
	$matches = listOfMatchesToQuery();		// uses upcomingfixtures.csv to get team names for regex search.
	$target_url = "http://www.betexplorer.com/soccer/england/premier-league/";
	$html = new simple_html_dom();
	$html->load_file($target_url);
	$subject = $html;
	
	
	foreach($matches as $pair){
		$pattern = "/".$pair[0]." - ".$pair[1].".*/";
		echo $pattern."</br>\n";
		if(preg_match($pattern, $subject, $matches)){
			echo "Matches: ".$matches[0]."</br>\n";
			if(preg_match_all('/\"\d\.\d\d\"/', $matches[0], $odds)){
				$matchodds=array();
				foreach($odds[0] as $o){
					$o = trim($o, "\"");
					$matchodds[] = $o;
				}
				appendToOddsList($matchodds, $pair);
			}
			else{
				echo "no match\n";
			}
		}
		else{ echo "Found no match";}
	}
	addNewOddsToFile($oddsList);
	
}

/*
$count - Number of matches we managed to get new odds for in the time limit
$upcmatchcount - total numbers of matches we could have gotten new odds for
*/
function addNewOddsToFile($filename, $count, $start){
	global $oddsList, $UpcMatchCount;
	$oddsfile = $filename;
	
	$oldOdds = getOldOddsFromFile($start);
	$NotUpdated = getNotUpdatedFromFile($start+$count);
	
	$fh = fopen($oddsfile, 'w') or die("can't open file");
	echo "Writing ".sizeof($oldOdds)." old match odds to file again...</br>\n";
	foreach($oldOdds as $odds){
		fwrite($fh, $odds);
	}
	echo "Writing ".$count." new match odds to file...</br>\n";
	foreach($oddsList as $matchOddsInfo){
		$string = "";
		foreach($matchOddsInfo as $data){
			$string = $string.$data.",";
		}
		fwrite($fh, rtrim($string, ", "));
		fwrite($fh, "\n");
	}
	echo "Writing ".sizeof($NotUpdated)." previously obtained odds of upcoming matches to file...</br>\n";
	foreach($NotUpdated as $odds){
		fwrite($fh, $odds);
	}
	fclose($fh);
}




function appendToOddsList($odds, $teamNamePair){
	global $oddsList;
	if(sizeof($odds) <4){
		$oddsList[] = array("1", $teamNamePair[0], $teamNamePair[1], $odds[0], $odds[1], $odds[2]);
	}
	else{
		$oddsList[] = array("1", $teamNamePair[0], $teamNamePair[1], $odds[0], $odds[1], $odds[2], $odds[3], $odds[4], $odds[5]);
	}
}

function exceededTimeLimit($startTime, $maxTime){
	if(time() - $startTime > $maxTime){ return true;}	
	return false;
}
/*
	Uses the upcomingfixtures-file to get pairs of team names that will play eachother. Then translates these names into names used on the betbrain website, and returns a 2xn array.
*/
function listOfMatchesToQuery(){
	global $teamNameTransWhoScoredToBetExplorer, $csv_upcomingFixtures;
	$resultArray = array();
	
	$fh = fopen($csv_upcomingFixtures, 'r') or die("can't open file");
	if ($fh) {
		while (($buffer = fgets($fh, 4096)) !== false) { // buffer is each line in $fh at a time
			$fixture = explode(",", $buffer); 			 // fixture = [gameID,homeID,awayID,homeName,awayName,date]
			if(array_key_exists($fixture[3], $teamNameTransWhoScoredToBetExplorer) && array_key_exists($fixture[4], $teamNameTransWhoScoredToBetExplorer)){
				$resultArray[] = array($teamNameTransWhoScoredToBetExplorer[$fixture[3]], $teamNameTransWhoScoredToBetExplorer[$fixture[4]]);
			}
			else{
				echo "Had problems matching team names from whoscored.com to betexplorer.com, the names tested were: ".$fixture[3]." and ".$fixture[4]."</br>";
			}
		}
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
	}
	else{ 
		echo "No new upcoming matches (for this month).";
	}
	return $resultArray;
}

function getBookieName($code){
	//echo "code: ".$code."</br>\n";
	$pattern = "/<\/span>.{1,30}<\/a>/";
	if(preg_match($pattern, $code, $result)){
		foreach($result as $r){
		//echo "result: ".$result[0]."</br>\n";
		}
		//echo "</br></br>";
		return substr($result[0], 7, strlen($result[0])-11);
		
	}
}

function findBestOdds($oddsList){ //bookiename, 1, x ,2
	$besthome = array("NA", 0);
	$bestdraw = array("NA",0);
	$bestaway = array("NA",0);
	foreach($oddsList as $bookie){
		//print_r($bookie);
		if($bookie[1] > $besthome[1]){
			//echo "New best home odds! </br>";
			$besthome[1] =$bookie[1];
			$besthome[0] = $bookie[0];
		}
		if($bookie[2] > $bestdraw[1]){
			//echo "New best draw odds! </br>";
			$bestdraw[1] =$bookie[2];
			$bestdraw[0] = $bookie[0];
		}
		if($bookie[3] > $bestaway[1]){
			//echo "New best away odds! </br>";
			$bestaway[1] =$bookie[3];
			$bestaway[0] = $bookie[0];
		}
	}
	//echo "BEST ODDS: ".$besthome[0]." ".$besthome[1]." - ".$bestdraw[0]." ".$bestdraw[1]." - ".$bestaway[0]." ".$bestaway[1]."</br>\n";
	return array($besthome[0],$besthome[1],$bestdraw[0],$bestdraw[1],$bestaway[0],$bestaway[1]);
}

function printUpcomingMatchesHTML(){
	global $csv_upcomingFixtures;
	$fh = fopen($csv_upcomingFixtures, 'r') or die("can't open file");
	if ($fh) {
		//echo "<th>asd</th>";
		while (($buffer = fgets($fh, 4096)) !== false) { // buffer is each line in $fh at a time
			$fixture = explode(",", $buffer); 			 // gameID,homeID,awayID,homeName,awayName,date
			foreach($fixture as $tag){
				trim($tag, ",' ");
			}
			//echo "<tr><td>".$fixture[3]."(".$fixture[1].") is playing ".$fixture[4]."(".$fixture[2].") on ".$fixture[5]."</td></tr>\n"; 
			echo "<tr class=\"inforow\"><td>".$fixture[3]."</td><td>".$fixture[4]."</td><td>".$fixture[5]."</td></tr>\n";
		}
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
	}
	else{ echo "No new upcoming matches (for this month).";}

}

/* Counts number of lines there are in the upcomingfixtures file, hence how many matches we can get odds for OBS may need to do a minus one here if we add titles to columns in this file.*/
function getUpcomingMatchesCount(){
	global $csv_upcomingFixtures;
	$upcomingfixtures = array();
	$fh = fopen($csv_upcomingFixtures, 'r') or die("can't open file");
	$count = 0;
	if ($fh) {
		
		while (($buffer = fgets($fh, 4096)) !== false) { // buffer is each line in $fh at a time
			$count++;
		}
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
		return $count;
	}
	else{ echo "No new upcoming matches (for this month).";}
}

function getOldOddsFromFile($count){
	
	global $csv_odds;
	$oldmatchodds = array();
	$fh = fopen($csv_odds, 'r') or die("can't open file");
	if ($fh) {
		
		while (($buffer = fgets($fh, 4096)) !== false) { // buffer is each line in $fh at a time
			$oldmatchodds[] = $buffer;
		}
		$oldmatchodds = array_slice($oldmatchodds, 0, $count);
		$oldoddscount =  $count;
		echo "Reading ".$oldoddscount." old match odds from file...</br>\n";
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
		//print_r($oldmatchodds);
		return $oldmatchodds;
	}
	return "Could not open file when attempting to get old odds from file";
}


function getNotUpdatedFromFile($frompos){
	global $csv_odds;
	$notUpdated = array();
	$fh = fopen($csv_odds, 'r') or die("can't open file");
	if ($fh) {
		
		while (($buffer = fgets($fh, 4096)) !== false) { // buffer is each line in $fh at a time
			$notUpdated[] = $buffer;
		}
		$notUpdated = array_slice($notUpdated, $frompos, sizeof($notUpdated));
		$notUpdatedCount = sizeof($notUpdated) - $frompos ;
		echo "Reading ".$notUpdatedCount." not updated match odds from file...</br>\n";
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($fh);
		$notUpdated = setAsNotUpdated($notUpdated);
		//print_r($notUpdated);
		return $notUpdated;
	}
	return "Could not open file when attempting to get not updated odds (upcoming matches that there weren't enough time to fetch new odds on)from file";
}

function setAsNotUpdated($arrayOfOdds){
	$result = array();
	foreach($arrayOfOdds as $odds){
	$result[] = substr_replace($odds, "0", 0,1);
	}
	return $result;
}

function testmethod2(){
	$array = array("1,manu,city,1,2,3,4,5","1,masadnu,city,1,2,3,4,5","1,manuasd,city,1,2,3,4,5","1,manu,cityasd,1,2,3,4,5");
	$array = setAsNotUpdated($array);
	print_r($array);
}

//testMethod();
//getBetBrainOdds();
//getOdds();

?>