<?php
include_once("simple_html_dom.php");

$nextMatchList = array();

$listOfMonths = array(			"jan" =>"01", 
								"feb" =>"02",
								"mar" =>"03",
								"apr" =>"04",
								"may" =>"05",
								"jun" =>"06",
								"jul" =>"07",
								"aug" =>"08",
								"sep" =>"09",
								"oct" =>"10",
								"nov" =>"11",
								"des" =>"12"); 

function getNextMatches(){
	echo "Getting Next Fixtures to be played...</br>";
	global $nextMatchList, $target_url_for_whoscored_upcoming_fixtures;
	$html = new simple_html_dom();
	$html->load_file($target_url_for_whoscored_upcoming_fixtures);
	$subject = $html;
	$foundNewMatches = false;
	if(preg_match("/DataStore.prime\('stagefixtures',.*\n(,.*\n)*\]\);/", $subject, $matches))
	{
		$schedule = explode("\n", $matches[0]);
		foreach($schedule as $match){
			if(preg_match("/,'-1',/", $match, $game)){
				//echo $match." IS  A NEXT MATCH </br>";
				if(strpos($match, 'Post') !== false){
					echo "Postponed match: ".$match."</br>\n";
					continue;
				}
				$foundNewMatches = true;
				$matchString = formatMatch($match);
				if(sizeof($nextMatchList) < 21){
					$nextMatchList[] = $matchString;
				}
				else{
					break;
				}
			}
			
		}
		if(!$foundNewMatches){
			echo "There were no current next matches found. Perhaps we are at the end of the month?";
		}
	}
	else{ 
		print_r("Error occured, should have found regex match with pattern. check getNextMatches function in get_odds.php line 50");
	}
	echo "Retrieval Complete!</br>";
	updateUpcomingMatchesFile();
}

function formatMatch($match){
	
	$resultString = "";
	$tempArray = explode(",", $match);
	if (strpos($match,'DataStore') !== false) {
		$tempArray = array_slice($tempArray,3);	//cut away part of $temparray preceeding position 4, for the first line, which is not of same format as rest of source-code retrieved.
		$tempArray[1] = ltrim($tempArray[1], " ");
	}
	$resultString = ltrim($tempArray[1], "[");
	$resultString = $resultString.",".$tempArray[6].",".$tempArray[9].",".$tempArray[7].",".$tempArray[10];
	
	$resultString = $resultString.",".getDefaultDateFormat($tempArray[4]);
	return $resultString;
}

function getDefaultDateFormat($string){
	//string format should be:' feb 23 2013'    . We want all numbers, with slashes.
	//print_r("</br> this is the string:".$string."</br>");
	$dateArray = explode(" ", $string);
	//echo sizeof($dateArray)." is the size of dateArray!";
	//echo "</br>".$dateArray[0]."</br>";
	$month = getMonth($dateArray[1]);
	$day = getDay($dateArray[2]);
	$year = getYear(rtrim($dateArray[3], "'"));
	return concatenate($day, $month, $year);
	
}

function updateUpcomingMatchesFile(){
	
	echo "Updating upcoming fixtures file... </br>";
	global $nextMatchList, $csv_upcomingFixtures;
	$fh = fopen($csv_upcomingFixtures, 'w') or die("can't open file");
	foreach($nextMatchList as $match){
		fwrite($fh, $match);
		fwrite($fh, "\n");
	}
	fclose($fh);
	
	echo "Completed updating upcoming fixture file!</br>";
}


function getMonth($month){
	
	if(strlen($month) >= 3){
		$temp = strtolower($month);
		$temp = trim($temp, " ,");	
		if(validMonth($temp)){
			return getNumericMonth($temp);
		}	
	}
	else{
		return "Month NA: less than three chars or not found in map of months. ARG:$month</br>";
	}
}

function getDay($day){
	$day = trim($day, " ,");		
	
	if(strlen($day)<2){
		return "0".$day;
	}
	return $day;
}

function getYear($year){
	$year = trim($year, " ,");		
	if(strlen($year)>2){
		return substr($year, 2,2);
	}
}

function validMonth($month){
	global $listOfMonths;
	return array_key_exists(substr($month, 0, 3), $listOfMonths);
}

function getNumericMonth($textualMonth){
	global $listOfMonths;
	return $listOfMonths[$textualMonth];
}

function concatenate($day, $month, $year){
	return $day."/".$month."/".$year;
}



//getNextMatches();

?>