<?php

/*  GLOBAL FIELDS			*/
$file = 'C:/Users/Martin/Documents/Skole/Footy/DATA/2012-13/crawled-PL.csv';
$fixtureFile = 'fixtureInfo.csv';
$oddsFile = 'odds12-13.csv';
$upcomingFile = 'upcomingfixtures.csv';

$empty_field_filler = "";	//could be ' ','NaN', '', etc. See what works.

$ODDS_titles = "oddsH,oddsD,oddsA\n";
$UPCOMING_filled_column_titles = "MatchID,HomeID,AwayID,HomeTeam,AwayTeam,Date";
$UPCOMING_empty_column_titles = "Result,HomeBlockedShots,HomeShotsOffTarget,HST,HomeHitPost,HS,HomeWonContests,HomeFKConceded,HomeThrows,HomeTackles,HomeOffsides,HomeCornersWon,HomeAttemptedPasses,HomeSuccessfulPasses,HomePossession,HomeAerialLost,HomeAerialWon,FTHG,AwayBlockedShots,AwayShotsOffTarget,AST,AwayHitPost,AS,AwayWonContests,AwayFKConceded,AwayThrows,AwayTackles,AwayOffsides,AwayCornersWon,AwayAttemptedPasses,AwaySuccessfulPasses,AwayPossession,AwayAerialLost,AwayAerialWon,FTAG";
$empty_columns_amount = 0;
/* Need two translation tables, as whoscored and betexplorer use two slightly different naming conventions */
/* These two tables must be expanded to include new teams if we wish to use data from a different league or different year (hence containing 3 new team names).
   For instance, using EPL 2013-14, we need to add three translations for the teams Cardiff, Hull etc. If we wish to use Championship 2013-14, we need to add names for all those teams.*/
$teamNameTranslationBEtoMATLAB = array(		"Arsenal"				=> "Arsenal",
									"Aston Villa"			=> "Aston Villa",
									"Chelsea"				=> "Chelsea",
									"Everton"				=> "Everton",
									"Fulham"				=> "Fulham",
									"Liverpool"				=> "Liverpool",
									"Manchester City"		=> "Man City",
									"Manchester United" 	=> "Man United",
									"Newcastle Utd"			=> "Newcastle",
									"Norwich"				=> "Norwich",
									"QPR"					=> "QPR",
									"Reading"				=> "Reading",
									"Southampton"			=> "Southampton",
									"Stoke City"			=> "Stoke",
									"Sunderland"			=> "Sunderland",
									"Swansea"				=> "Swansea",
									"Tottenham"				=> "Tottenham",
									"West Brom"				=> "West Brom",
									"West Ham"				=> "West Ham",				
									"Wigan"					=> "Wigan"				
													);


$teamNameTranslationWStoMATLAB = array(		"'Arsenal'"				=> "Arsenal",
									"'Aston Villa'"			=> "Aston Villa",
									"'Chelsea'"				=> "Chelsea",
									"'Everton'"				=> "Everton",
									"'Fulham'"				=> "Fulham",
									"'Liverpool'"			=> "Liverpool",
									"'Manchester City'"		=> "Man City",
									"'Manchester United'" 	=> "Man United",
									"'Newcastle United'"	=> "Newcastle",
									"'Norwich'"				=> "Norwich",
									"'Queens Park Rangers'"	=> "QPR",
									"'Reading'"				=> "Reading",
									"'Southampton'"			=> "Southampton",
									"'Stoke'"				=> "Stoke",
									"'Sunderland'"			=> "Sunderland",
									"'Swansea'"				=> "Swansea",
									"'Tottenham'"			=> "Tottenham",
									"'West Bromwich Albion'"=> "West Brom",
									"'West Ham'"			=> "West Ham",				
									"'Wigan'"				=> "Wigan"				
													);

/*	GLOBAL FIELDS END	*/


function translate(){
	echo "Started translating for matlab...</br>\n";
	
	global $fixtureFile, $oddsFile, $upcomingFile, $file, $teamNameTranslationWStoMATLAB, $teamNameTranslationBEtoMATLAB;	
	$fixtureInfo = readFileInfo($fixtureFile);
	$fixtureInfo = translateNames($fixtureInfo, $teamNameTranslationWStoMATLAB);
	$fixtureInfo = translateDates($fixtureInfo);
	$fixtureInfo = translateResults($fixtureInfo);
	$fixtureInfo = removeLineEndings($fixtureInfo);
	
	$upcomingInfo = readFileInfo($upcomingFile);
	$upcomingInfo = translateNames($upcomingInfo, $teamNameTranslationWStoMATLAB);
	$upcomingInfo = removeLineEndings($upcomingInfo);
	
	$odds = readFileInfo($oddsFile);
	$odds = getOddsAndTeamNames($odds);
	$odds = removeLineEndings($odds);
	if (strpos($odds[0],'ERROR') !== false) {
		echo "Translation for matlab cancelled, error occurred</br>";
		return;
	}
	$odds = translateNames($odds, $teamNameTranslationBEtoMATLAB);
	//print_r($upcomingInfo);
	$fixtureInfo = matchOnNamesAndConcatenateArrays($odds, $fixtureInfo, $upcomingInfo);
	//print_r($fixtureInfo);
	writeToFile($fixtureInfo, $file);
	echo "Translation for matlab complete.</br>\n";
}

function writeToFile($array, $file){
	$fh = fopen($file, 'w') or die("can't open file");
	foreach($array as $line){
		fwrite($fh, $line);
	}
	fclose($fh);
}

function readFileInfo($file){
	$result = array();
	$fh = fopen($file, 'r') or die("can't open file");
	if ($fh) {
		while (($buffer = fgets($fh, 4096)) !== false) {
				$result[] = $buffer;
		}
		if (!feof($fh)) {
			echo "Error: unexpected fgets() fail\n";
			fclose($fh);
		}
		
	}
	fclose($fh);
	return $result;
}

function translateNames($infoArray, $teamNameTranslation){
	$result = array();
	$temp;
	foreach($infoArray as $fixture){
		$temp = $fixture;
		foreach($teamNameTranslation as $key => $value){
				$temp = str_replace($key, $value, $temp);
		}
		$result[] = $temp;
	}
	
	return $result;
}


function matchOnNamesAndConcatenateArrays($oddsList, $fixtureList, $upcomingInfo){
	
	global $ODDS_titles,$UPCOMING_filled_column_titles,$UPCOMING_empty_column_titles, $empty_field_filler, $empty_columns_amount;
	
	$result = array();
	$result[] = $UPCOMING_filled_column_titles.",".$UPCOMING_empty_column_titles.",".$ODDS_titles;
	$empty_columns_amount = sizeof(explode(",",$UPCOMING_empty_column_titles));
	echo $result[0]." ".$empty_columns_amount;
	//print_r($oddsList);
	//print_r($fixtureList);
	$foundMatch = false;
	
	foreach($oddsList as $odds){
		echo "Started search for: ".$odds."</br>";
		$teamNameOdds = explode(",",$odds);
		
		$foundMatch = false;
		foreach($fixtureList as $fixture){
			//echo "comparing with ".$fixture."</br>";
			$teamNameFixture = explode(",",$fixture);
			//echo $teamNameOdds[1]." ".$teamNameFixture[3]." ".$teamNameOdds[2]." ".$teamNameFixture[4]."</br>";	
			if($teamNameOdds[1] == $teamNameFixture[3] && $teamNameOdds[2] == $teamNameFixture[4]){ //Found! Can connect the lines!
				echo "This was a match!</br>";
				$foundMatch = true;
				$result[] = connectLines($odds, $fixture, true);
				break;
			}
		}
		if($foundMatch){
			continue;
		}
		foreach($upcomingInfo as $upcoming){
			$teamNameUpcoming = explode(",",$upcoming);
			if($teamNameOdds[1] == $teamNameUpcoming[3] && $teamNameOdds[2] == $teamNameUpcoming[4]){ //Found! Can connect the lines!
				$foundMatch = true;
				$result[] = connectLines($odds,$upcoming, false);
				break;
			}
		}
		if(!$foundMatch){
			echo "ERROR: did not find a match for: ";
			print_r($odds);
			echo "</br>\n";
			return;
		}
	}
	return $result;
	

}

function connectLines($odds, $other, $isFilled){
	global $empty_columns_amount, $empty_field_filler;
	echo "Found match: ".$odds." AND ".$other."</br>\n";
	$odds = explode(",",$odds);
	if($isFilled){
		echo $other.",".$odds[3].",".$odds[4].",".$odds[5];
		return $other.",".$odds[3].",".$odds[4].",".$odds[5]."\n";
	}
	else{
		$result = $other;
		for($i = 0; $i < $empty_columns_amount; $i++){
			$result = $result.",".$empty_field_filler;
		}
		echo $result.",".$odds[3].",".$odds[4].",".$odds[5];
		return $result.",".$odds[3].",".$odds[4].",".$odds[5]."\n";
	}
	
}


// Date should be in position 5 (counting from 0)
function translateDates($infoArray){
	$result = array();
	
	foreach($infoArray as $fixture){
		$fixtureArray = explode(",", $fixture);
		$oldDateFormat = $fixtureArray[5];
		$date = translateDate($oldDateFormat);
		//echo $date." from ".$oldDateFormat."</br>\n";
		$result[] = str_replace($oldDateFormat,$date,$fixture);
	}
	return $result;
}

// Result should be in position 6 (counting from 0)
function translateResults($infoArray){
	$result = array();
	
	foreach($infoArray as $fixture){
		$fixtureArray = explode(",", $fixture);
		$oldResultFormat = $fixtureArray[6];
		$gameResult = translateResult($oldResultFormat);
		$result[] = str_replace($oldResultFormat, $gameResult, $fixture);
	}
	return $result;
}

function translateResult($oldResultFormat){// '1 : 0' for example 
	if(strlen($oldResultFormat)<7){return $oldResultFormat;} //was title
	$homeGoals = substr($oldResultFormat,1,1);
	$awayGoals = substr($oldResultFormat,5,1);
	if($homeGoals > $awayGoals) return "H";
	if($homeGoals < $awayGoals) return "A";
	if($homeGoals == $awayGoals)return "D";
	echo "Somethining is wrong for result: ".$homeGoals." ".$awayGoals;
}

function translateDate($date){ 
	if(strlen($date)<10){ return $date;}
	$month = substr($date,1,2);
	$day = substr($date,4,2);
	$year = substr($date,9,2);
	return $day."/".$month."/".$year;
}

function removeLineEndings($array){
	$result = array();
	foreach($array as $string){
		$result[] = rtrim($string, "\n");
	}
	return $result;
}

/*
	Title form: Updated,HomeTeam,AwayTeam,bookienameH,oddsH,bookienameD,oddsD,bookieameA,oddsA
	returns the three rows oddsH,-D and -A, for concatinating with fixtureInfo. team names are needed to match lines from odds.csv and fixtureInfo.csv, 
	since they are not in the same order.
	Each string in the result array starts with a ','.
	
*/
function getOddsAndTeamNames($odds){
	$result = array();
	$i = 0;
	foreach($odds as $matchodds){
		//echo $i++."</br>\n";
		$temp = explode(",",$matchodds);
		if(isValidOdds(array($temp[4], $temp[6], $temp[8]))){
			$result[] = ",".$temp[1].",".$temp[2].",".$temp[4].",".$temp[6].",".$temp[8];
		}
		else{
		 echo "Format of odds is not correct! ".$temp[1]." - ".$temp[2].": ".$temp[4]." - ".$temp[6]." - ".$temp[8]."</br>";
		 $result[0] = "ERROR: incorrect format!";
		 return $result;
		}
	}
	return $result;
	
}

function isValidOdds($oddsArray){
	foreach($oddsArray as $odds){
		if(preg_match("/\d?\d\.\d\d/", $odds, $result)){
			//echo $odds." was ok\t";
			continue;
		}
		return false;
	}
	return true;

}

translate();

?>