<?php
// ********** Globals **********
//******************************

// EPL 2012-13
$target_url_for_whoscored_league_table = "http://www.whoscored.com/Regions/252/Tournaments/2/England-Premier-League";
$target_url_for_whoscored_upcoming_fixtures = "http://www.whoscored.com/Regions/252/Tournaments/2/Seasons/3389/Stages/6531/Fixtures/England-Premier-League-2012-2013";
$target_url_for_betexplorer_odds = "http://betexplorer.com/soccer/england/premier-league/";

// championship 2012-13
//$target_url_for_whoscored_league_table = "http://www.whoscored.com/Regions/252/Tournaments/7/Seasons/3390/Stages/6532";
//$target_url_for_whoscored_upcoming_fixtures = "http://www.whoscored.com/Regions/252/Tournaments/7/Seasons/3390/Stages/6532/Fixtures/England-Championship-2012-2013";
//$target_url_for_betexplorer_odds = "http://www.betexplorer.com/soccer/england/championship/";



$stageID = "6531";								// Used in regex matching, be sure to update this variable if changing $target_url_for whoscored_upcoming_fixtures, see getWhoScoredTable()

$league_and_year = 		"EPL 2012-13"; 				// Folder name for finding correct set of csv-files.


$raw_file = 			"../".$league_and_year."/testFile.txt";
$csv_table = 			"../".$league_and_year."/table.csv";
$csv_matches = 			"../".$league_and_year."/matches.csv";
$csv_legacyMatches= 	"../".$league_and_year."/legacy-matches.csv";
$csv_fixtureInfo = 		"../".$league_and_year."/fixtureInfo.csv";
$csv_upcomingFixtures = "../".$league_and_year."/upcomingfixtures.csv";
$csv_odds = 			"../".$league_and_year."/odds.csv";

//*****************************
//*****************************


//All the following methods are used to get the premier league's current table.

//include crawler methods to read html
include_once("simple_html_dom.php");
include 'whoscored_match_info.php';
include 'get_upcoming_fixtures.php';
include 'get_odds.php';

//this method simply gets the javascript from whoscored.com which has the information needed to construct the current premier league table.
//The last three fields for each team are strings containing html for total-table, home-table and away-table. Not yet in use.
//The returned matches object has all the information in the first field of the array, i.e. matches[0].

/*

1

*/

$newFixturesInMatchList = false;


function getWhoScoredTable()
{
	global $target_url_for_whoscored_league_table, $stageID;
	$html = new simple_html_dom();
	$html->load_file($target_url_for_whoscored_league_table);

	$subject = $html;
	$pattern = "/DataStore\.prime\('standings', { stageId: ".$stageID." }, \[(\[.*\n,?)+/";
	//echo $subject;
	if(preg_match($pattern, $subject, $matches))
	{
		for($i = 0; $i < sizeof($matches); $i++)
		{
			//echo "</br>$i is: {$matches[$i]}</br>";
		}
	}
	
	
	return $matches;
}

/*
//uses the getWhoScoredTable() method, and builds a raw-file with all the information, but does nothing to structure it.
2

*/
function updateRawTableInfo()
{
	global $raw_file;
	
	echo "Updating Raw File... </br>";
	$info = getWhoScoredTable();
	$fh = fopen($raw_file, 'w') or die("can't open file");
	fwrite($fh, $info[0]);
	echo "Done updating raw file: $raw_file!</br>";
	fclose($fh);
}

/*
//Updates the csv (comma-separated-values) file which holds the organized table-information.
3

*/
function updateTable()
{
	global $raw_file, $csv_table;
	echo "Updating Table... </br>";
	$handle = @fopen($raw_file, "r");
	$fh = fopen($csv_table, 'w') or die("can't open file $csv_table");
	if ($handle) {
		fwrite($fh, "TeamId,TeamName,Position,Played,Wins,Draws,Losses,GoalsFor,GoalsAgainst,GoalDifference,Points,PositionHome,PlayedHome,WinsHome,DrawsHome,LossesHome,GoalsForHome,GoalsAgainstHome,GoalDifference,PointsHome,PositionAway,PlayedAway,WinsAway,DrawsAway,LossesAway,GoalsForAway,GoalsAgainstAway,GoalDifference,PointsAway\n");
		while (($buffer = fgets($handle, 4096)) !== false) {
			$formattedText = formatTable($buffer);
			
			//echo $formattedText;
			//echo "</br>";
			fwrite($fh, $formattedText);
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
		fclose($fh);
		echo "written to file $csv_table";
	}
	echo "Done updating table! </br>";
}


/*

4 update the matches.csv file, containing a list of all teams with matchIDs for games each team has played. Will only contain the max 12 last games each team has played.
  legacymatches.csv is the entire list of matches played for each team. This file is updated in the final line of this function.

*/
function updateMatches(){

	global $raw_file, $csv_matches;
	echo "Updating match list... </br>";
	$handle = @fopen($raw_file, "r");
	$fh = fopen($csv_matches, 'w') or die("can't open file");
	if ($handle) {
		while (($buffer = fgets($handle, 4096)) !== false) {
			$formattedText = formatMatches($buffer);
			
			//echo $formattedText;
			//echo "</br>";
			fwrite($fh, $formattedText);
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
		fclose($fh);
		updateLegacyMatches();
	}
	echo "Done updating match list!</br>";
}

/*
//<a class="l a" id="614113" title="Chelsea 2-0 Newcastle United"/>

5

*/
function formatMatches($text){
	$string="";
	$string = getTeamNameAndID($text);
	//find game id-tags
	preg_match_all('/id="[0-9]+"/', $text, $matches);
	foreach ($matches as $val) {
		foreach ($val as $game) {
			$game = trim($game, "id=\"");
			if(!preg_match("/$game/", $string, $id)){
				$string = "$string$game,";
			}
			//echo $game;
		}
	}
	$string = substr($string, 0, strlen($string)-1);
	$string = "$string\n";
	return $string;
}


//The format-method used to make it easier to read and use the table information.
/*

6

*/
function formatTable($text)
{
	$csvText = "";
	$list = explode(",", $text);
	if(preg_match("/DataStore/", $list[0], $matches))
	{
		
		for($i = 3; $i < 32; $i++){
			//echo "$i: {$list[$i]} </br>";
			$csvText = "$csvText$list[$i],";  
		}
	}
	else
	{
		for($i = 2; $i < 31; $i++){
			//echo "$i: {$list[$i]} </br>";
			$csvText = "$csvText$list[$i],";  
		}
	}
	$num = strlen($csvText);
	$csvText = substr($csvText, 0, strlen($csvText)-1);
	$csvText = "$csvText\n";
	return $csvText;
}


/*

7

*/
function getTeamNameAndID($text){
	$string = "";
	preg_match('/\[[0-9]+,[0-9]+,\'[A-Z a-z]+\'/', $text, $id);
	
	$string = trim($id[0], "[");
	$array = explode(",", $string);
	$string = "$array[1],$array[2],";
	//echo $string."</br></br>";
	return $string;
}

/*
//Reads lines from the csv-file, and returns a multi-dimensional array with one value in each "square".
//Typestring should be either "overall", "home" or "away" to determine which table to show.
8
*/
function getTableArray($typeString)
{
	global $csv_table;
	$handle = @fopen($csv_table, "r");
	$array = array();
	if ($handle) {
		$countLinesRead = 0;
		$whatToShow=0;
		$pick = 0;
		
		
		if($typeString == "home") $whatToShow= 10;
		else if ($typeString == "away") $whatToShow = 19;
		else{$whatToShow = 1;}
		
		
		while (($buffer = fgets($handle, 4096)) !== false) {
			if($countLinesRead == 0){
				$array = insertHeadersToTable($typeString);
				
			}
			else{
				$list = explode(",", $buffer);
				for($i = 0; $i < 10; $i++){
					if($i == 0)$pick = 1;
					else{ $pick = $whatToShow+$i;}
					
					$array[$countLinesRead][$i] = $list[$pick];
					//echo $array[$countLines][$i]."</br>";
				}
			}
			$countLinesRead++;
			
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
		
	}
	return $array;

}

/*
//Gets the type of table wanted, and alters the headers to be more compact while giving more meaning than a generic one.
9
*/
function insertHeadersToTable($typeString){
	$array = array();
	
	if($typeString == "overall"){
		$array[0][0] = "Teams";
		$array[0][1] = "Pos";
		$array[0][2] = "P";
		$array[0][3] = "W";
		$array[0][4] = "D";
		$array[0][5] = "L";
		$array[0][6] = "GF";
		$array[0][7] = "GA";
		$array[0][8] = "GD";
		$array[0][9] = "Points";
	}
	else if($typeString == "home"){
		$array[0][0] = "Teams";
		$array[0][1] = "H-Pos";
		$array[0][2] = "H-P";
		$array[0][3] = "H-W";
		$array[0][4] = "H-D";
		$array[0][5] = "H-L";
		$array[0][6] = "H-GF";
		$array[0][7] = "H-GA";
		$array[0][8] = "H-GD";
		$array[0][9] = "H-Points";
	}
	else if($typeString == "away"){
		$array[0][0] = "Teams";
		$array[0][1] = "A-Pos";
		$array[0][2] = "A-P";
		$array[0][3] = "A-W";
		$array[0][4] = "A-D";
		$array[0][5] = "A-L";
		$array[0][6] = "A-GF";
		$array[0][7] = "A-GA";
		$array[0][8] = "A-GD";
		$array[0][9] = "A-Points";
	}
	return $array;
	
}

/*
//prints html-code with table inside. $typestring signifies overall, away or home statistics for each team.
10
*/
function printTable($typeString){
		$table = getTableArray($typeString);
		
		for($i=0; $i < sizeof($table); $i++)
		{
			if($i==0){
				echo "<tr class = \"title\">\n\t";
			}
			else{
				if($i % 2 == 1){
				echo "<tr class = \"team1\">\n\t";
				}
				else{
				echo "<tr class = \"team2\">\n\t";
				}
			}
			for($j=0;$j < sizeof($table[$i]); $j++)
			{
				
				echo "<td>".$table[$i][$j]."</td>";
			}
			echo "</tr>\n\t";
		}
}

/*
11 Add new matches to the legacy file, which should contain all matches of the season (legacy-matches.csv)

*/
function updateLegacyMatches(){
	global $newFixturesInMatchList, $csv_legacyMatches, $csv_matches;
	echo "updating legacy matches!";
	
	//$fh = fopen($csvLegacyMatches, 'w') or die("can't open file");
	$linesRead = 0;
	$newMatches = array();
	$allMatches = array();
	
	$handle = @fopen($csv_matches, "r");
	if ($handle) {
		while (($buffer = fgets($handle, 4096)) !== false) { // buffer is each line in $handle at a time
			$tempNewMatches = explode(",", $buffer);
			for($i = 0; $i < count($tempNewMatches); $i++)
			{
				$newMatches[$linesRead][$i] = trim($tempNewMatches[$i], ",\n");
			}
			$linesRead++;
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
	}
	
	$handle = @fopen($csv_legacyMatches, "r");
	$linesRead = 0;
	
	if ($handle) {
		while (($buffer = fgets($handle, 4096)) !== false) { // buffer is each line in $handle at a time
			$tempNewMatches = explode(",", $buffer);
			for($i = 0; $i < count($tempNewMatches); $i++)
			{
				$allMatches[$linesRead][$i] = trim($tempNewMatches[$i], ",\n");
			}
			$linesRead++;
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
	}
	if($linesRead == 0){
		echo "<br>LegacyMatches seems to be empty!</br>, Assuming start of season and setting legacy-matches.csv as matches.csv<br>";
		$legacyMatches = $newMatches;
		$newFixturesInMatchList = true;
	}
	else{
		$legacyMatches = appendNewMatchesToList($allMatches, $newMatches);
	}
	if($newFixturesInMatchList){
		$fh = fopen($csv_legacyMatches, 'w') or die("can't open file");
		foreach($legacyMatches as $line){
			$fixtureInfo = "";
			foreach($line as $fixture){
				$fixtureInfo = $fixtureInfo.$fixture.",";
				
			}
			
			$fixtureInfo = rtrim($fixtureInfo, ",\n")."\n";
			
			fwrite($fh, $fixtureInfo);
		}
	
		echo "written to file</br>";
		fclose($fh);
	}
	else{
		echo "</br>Nothing to update!</br>";
	}
	echo "Done updating legacy file!</br>";
}

/*
12 each parameter is a 2dim array, each line should contain values such as "13, man utd, 12410, 1230141, 123102"
   This function adds any matchid found in $new that isn't already in $legacy, and returns $legacy
*/
function appendNewMatchesToList($legacy, $new){ 
	global $newFixturesInMatchList;
	$result = array();
	$i = 0;
	foreach($new as $newTeamInfo){
		
		$legacyTeamInfo = findSameTeam($newTeamInfo[0], $legacy); 
		if(containsNewInformation($newTeamInfo, $legacyTeamInfo)){ 
			$newFixturesInMatchList = true;
			$toBeAdded = findNewMatches($newTeamInfo, $legacyTeamInfo); 
			$result[$i] = $legacyTeamInfo;
			for($j=0; $j < sizeof($toBeAdded); $j++){
				$result[$i][sizeof($legacyTeamInfo)+$j] = $toBeAdded[$j];
			}
			
		}
		else{
			$result[$i] = $legacyTeamInfo;
		}
		$i++;
		
	}
	return $result;
}


/*
13 Uses an id to match with first element of each row in a 2dim array. 
   Returns the row where id matches, or string if no match found
*/
function findSameTeam($id, $list){
	
	foreach($list as $item){
		if($item[0] == $id) return $item;
	}
	echo "No id match was found in the list provided when trying to find same team in each. The id searched for was".$id;
	echo "</br>";
	return "No id match was found in the list provided.";
}

/*

14 Returns true if there are elements in newlist that do not exist in oldlist.
*/

function containsNewInformation($newList, $oldList){
	foreach($oldList as $i){
		//echo "</br>".$i;
	}
	foreach($newList as $item){
		if(!in_array($item, $oldList)) return true;
	}
	echo "No new fixtures for ".$oldList[1]."</br>";
	return false;
}


/*
15 returns an array containing every missing item in oldlist which exists in newlist
*/
function findNewMatches($newList, $oldList){
	$result = array();
	foreach($newList as $item){
		if(!in_array($item, $oldList) && !in_array($item, $result)) $result[] = $item;
	}
	return $result;
}

function testMethod(){
	$new = array(array("13","Arsenal","31","42","54"),array("12","Man U","6","41","43","45\n"),array("11","City","3","4","5"));
	$old = array(array("13","Arsenal","31","42","54"),array("12","Man U","6","41"),array("11","City","3","4"));
	$result = appendNewMatchesToList($old, $new);
	$string = "hallo! how are you!,";
	echo $string;
	echo rtrim($string, ",\n");
	foreach($result as $line){
		
		foreach($line as $fixture){
			$fixture = trim($fixture);
		}
	}
	
	
	foreach($result as $team){
		foreach($team as $items){
			echo "</br>".$items;
		}
		echo "</br>";
	}
}

/* contains all the update-functions described below, to update all db-files in one go.

	updates: raw-file->table->matchlist-> legacy-matchlist->fixtureInfo-list.
	
*/

function updateAll(){
	updateRawTableInfo();
	updateTable();
	updateMatches();
	GetNewMatchObjects();
	getNextMatches();

}

//testMethod(); 		//simple testmethod for testing some of the functions programmed in this file. Often altered for ad hoc needs.




//To update table, run the two following commands:

//updateRawTableInfo(); //Crawls whoscored.com and gets the new unformatted data which holds the 
						//newest tableinformation, and is also used to find the 12 newest match id's for each team.
						//Stores data in testFile.csv. This file is used by the other functions to extract and update data,
						//So start by running this method first.

//updateTable();		//Gets information from testFile.csv and updates the table, saved in the table.csv file.

//updateMatches();		// Updates the matches.csv file, which contains the 12 newest match id's for each team. Updating this file
						// means that we first must ensure that the testFile.csv, containing raw data, is updated as well.
						// PS! Last line of function legacy-matches.csv is also updated. This can be commented out if
						// we would like to update the two files in two steps.

//updateLegacyMatches();// Run this method for updating the csv-file which contains the entire list of matches played by each team.
						// This is done by checking matches.csv for new games, and adding this to the legacymatches.csv list.
						// Make sure there are no double commas or lines ending with commas, in either of the files when running this. 
						
						//To update csv files, but without altering the raw-file, run the following two commands: (can be run separately)
						//This is useful if we wish to check that the update functions work properly, and thus keeping the rawfile  (testFile.csv) constant
						//makes bug-checking easier.
//updateMatches();
//updateTable();
//getBestOdds();
//testmethod2();
//getSpecificOdds("William Hill");
//getBookieOdds("http://betexplorer.com/soccer/england/premier-league/nextmatch.php?matchid=1345420", "William Hill");
//getBetExplorerOdds();

//GetNewMatchObjects();
//getNextMatches();
//updateAll();




?>
